diff -ruN ../nakedmudv3.7.9/src/scripts/pystorage.c src/scripts/pystorage.c
--- ../nakedmudv3.7.9/src/scripts/pystorage.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pystorage.c	2009-04-05 12:59:31.000000000 -0400
@@ -64,7 +64,41 @@
 //
 // initialize a new storage list
 int PyStorageList_init(PyStorageList *self, PyObject *args, PyObject *kwds) {
+  // are we building this from a Python list?
+  PyObject *pylist = NULL;
+  if(!PyArg_ParseTuple(args, "|O", &pylist)) {
+    PyErr_Format(PyExc_TypeError, "unexpected arguments passed to StorageList.");
+    return -1;
+  }
+  
+  // if we received something, make sure it's a list
+  if(pylist != NULL && !PyList_Check(pylist)) {
+    PyErr_Format(PyExc_TypeError, "StorageList expected a list argument.");
+    return -1;
+  }
+
+  // create the storage list
   self->list = new_storage_list();
+
+  // try adding contents to the storage list
+  if(pylist != NULL) {
+    int i;
+    // first, make sure they're all storage sets
+    for(i = 0; i < PyList_Size(pylist); i++) {
+      PyObject *set = PyList_GetItem(pylist, i);
+      if(!PyStorageSet_Check(set)) {
+	PyErr_Format(PyExc_TypeError, "StorageList list content to be a StorageSet.");
+	return -1;
+      }
+    }
+
+    // all good, append them
+    for(i = 0; i < PyList_Size(pylist); i++) {
+      PyObject *set = PyList_GetItem(pylist, i);
+      storage_list_put(self->list, PyStorageSet_AsSet(set));
+    }
+  }
+
   return 0;
 }
 
@@ -115,9 +149,11 @@
 //*****************************************************************************
 PyMethodDef PyStorageList_class_methods[] = {
   {"sets", PyStorageList_sets, METH_VARARGS,
-   "Returns a python list of all the sets in the storage list" },
+   "sets()\n\n"
+   "Returns a python list of all the sets in the storage list." },
   {"add",  PyStorageList_add,  METH_VARARGS,
-   "Adds a new storage set to the list" },
+   "add(storage_set)\n\n"
+   "Append a new storage set to the storage list." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -143,7 +179,9 @@
     0,                                /*tp_setattro*/
     0,                                /*tp_as_buffer*/
     Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
-    "storage lists",                  /* tp_doc */
+    "__init__(self, list=None)\n\n"
+    "Create a new storage list. A Python list of storage sets may be\n"
+    "supplied, from which to build the storage list.",
     0,		                      /* tp_traverse */
     0,		                      /* tp_clear */
     0,		                      /* tp_richcompare */
@@ -262,8 +300,10 @@
 // read a boolean value from the storage set
 PyObject *PyStorageSet_readBool  (PyObject *self, PyObject *args) { 
   char *key = PyStorageSet_readParseKey(args);
-  if(key != NULL) 
-    return Py_BuildValue("i", read_bool(((PyStorageSet *)self)->set, key));
+  if(key != NULL) {
+    bool val = read_bool(((PyStorageSet *)self)->set, key);
+    return Py_BuildValue("O", (val ? Py_True : Py_False));
+  }
   else
     return NULL;
 }
@@ -396,42 +436,51 @@
 PyMethodDef PyStorageSet_class_methods[] = {
   // read functions
   { "readString", PyStorageSet_readString, METH_VARARGS,
-    "Read in the string value of a storage set entry, by key." },
+    "readString(name)\n\n"
+    "Read a string value from the storage set. Return empty string if the\n"
+    "storage set does not contain an entry by the given name." },
   { "readInt",    PyStorageSet_readInt,    METH_VARARGS,
-    "Read in the integer value of a storage set entry, by key." },
+    "Same as readString, for integers. Returns 0 if entry does not exist." },
   { "readDouble", PyStorageSet_readDouble, METH_VARARGS,
-    "Read in the double value of a storage set entry, by key." },
+    "Same as readString, for floating points. Returns 0 if entry does not exist.." },
   { "readBool",   PyStorageSet_readBool,   METH_VARARGS,
-    "Read in the boolean value of a storage set entry, by key." },
+    "Same as readString, for booleans. Returns False if entry does not exist."},
   { "readList",   PyStorageSet_readList,   METH_VARARGS,
-    "Read in the list value of a storage set entry, by key." },
+    "Same as readString, for storage lists. Returns an empty storage list\n"
+    "if entry does not exist." },
   { "readSet",    PyStorageSet_readSet,   METH_VARARGS,
-    "Read in the set value of a storage set entry, by key." },
+    "Same as readString, for storage sets. Returns an empty set if entry\n"
+    "does not exist." },
 
   // write store functions
   { "storeString", PyStorageSet_storeString, METH_VARARGS,
-    "Store the string value of a storage set entry, by key." },
+    "storeString(name, val)\n\n"
+    "Store a string value in the storage set." },
   { "storeInt",    PyStorageSet_storeInt,    METH_VARARGS,
-    "Store the integer value of a storage set entry, by key." },
+    "Same as storeString, for integers." },
   { "storeDouble", PyStorageSet_storeDouble, METH_VARARGS,
-    "Store the double value of a storage set entry, by key." },
+    "Same as storeString, for floating point values." },
   { "storeBool",   PyStorageSet_storeBool,   METH_VARARGS,
-    "Store the boolean value of a storage set entry, by key." },
+    "Same as storeString, for boolean values." },
   { "storeList",   PyStorageSet_storeList,   METH_VARARGS,
-    "Store the list value of a storage set entry, by key." },
+    "Same as storeString, for storage lists." },
   { "storeSet",    PyStorageSet_storeSet,    METH_VARARGS,
-    "Store the set value of a storage set entry, by key." },
+    "Same as storeString, for storage sets." },
 
   // other functions
   { "write",       PyStorageSet_write,       METH_VARARGS,
-    "Store the contents of the storage set to the specified filename" },
-  { "close",       PyStorageSet_close,       METH_VARARGS,
-    "Close a storage set. MUST be called when the storage set is done "
-    "being used. Garbage collection will not delete the set." },
+    "write(filename)\n\n"
+    "Write the contents of a storage set to the specified file name." },
+  { "close",       PyStorageSet_close,       METH_NOARGS,
+    "close()\n\n"
+    "Recursively close a storage set and all of its children sets and lists.\n"
+    "MUST be called when the storage set has finished being used. Garbage\n"
+    "collection will not delete the set." },
   { "contains",    PyStorageSet_contains,    METH_VARARGS,
-    "Returns True if the set contains the given key, and false otherwise." },
+    "contains(name)\n\n"
+    "Returns True or False if the set contains an entry by the given name." },
   { "__contains__",    PyStorageSet_contains,    METH_VARARGS,
-    "Returns True if the set contains the given key, and false otherwise." },
+    "__contains__(name) <==> name in self" },
 
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
@@ -459,7 +508,9 @@
     0,                                /*tp_setattro*/
     0,                                /*tp_as_buffer*/
     Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
-    "storage sets",                   /* tp_doc */
+    "__init__(self, filename=None)\n\n"
+    "Create a new storage set. If a file name is supplied, read a storage set\n"
+    "in from the specified file.",
     0,		                      /* tp_traverse */
     0,		                      /* tp_clear */
     0,		                      /* tp_richcompare */
@@ -494,7 +545,11 @@
 //*****************************************************************************
 PyMODINIT_FUNC init_PyStorage(void) {
   PyObject *module = Py_InitModule3("storage", PyStorage_module_methods,
-				    "Python wrapper for storage sets.");
+    "The storage module allows users to save information to disk as key:value\n"
+    "pairs without having to interact with files directly. This module gives\n"
+    "users access to two classes: StorageSets and StorageLists. Sets match\n"
+    "keys to values. Lists hold multiple sets.");
+
   // something went wrong... abort!
   if(module == NULL)
     return;
diff -ruN ../nakedmudv3.7.9/src/scripts/trigedit.c src/scripts/trigedit.c
--- ../nakedmudv3.7.9/src/scripts/trigedit.c	2009-03-02 01:08:06.000000000 -0500
+++ src/scripts/trigedit.c	2009-04-01 14:02:18.000000000 -0400
@@ -11,6 +11,7 @@
 #include "../utils.h"
 #include "../world.h"
 #include "scripts.h"
+#include "trighooks.h"
 
 
 
@@ -84,59 +85,28 @@
 #define TEDIT_NAME       1
 #define TEDIT_TYPE       2
 
-struct trigger_type_usable_list {
-  char    *type;
-  char *used_by;
-};
-
-// a table of allowable trigger types
-struct trigger_type_usable_list trigger_types[] = {
-  { "speech",         "mob, room" },
-  { "greet",          "mob"       },
-  { "enter",          "mob, room" },
-  { "exit",           "mob, room" },
-  { "self_enter",     "mob"       },
-  { "self_exit",      "mob"       },
-  { "drop",           "obj, room" },
-  { "get",            "obj, room" },
-  { "give",           "obj, mob"  },
-  { "receive",        "mob"       },
-  { "wear",           "obj, mob"  },
-  { "remove",         "obj, mob"  },
-  { "reset",          "room"      },
-  { "look",           "obj, mob, room" },
-  { "open",           "obj, room" },
-  { "close",          "obj, room" },
-  { "to_game",        "obj, mob, room" },
-  { "", "" },
-};
-
-int num_trig_types(void) {
-  static int num = -1;
-  // we need to calculate...
-  if(num == -1)
-    do { num++; } while(*trigger_types[num].type);
-  return num;
-}
-
-// returns the trigger type name, for the given number
-const char *triggerTypeGetName(int num) {
-  return trigger_types[num].type;
-}
-
-// returns the types of things the trigger can be attached to
-const char *triggerTypeGetUsedBy(int num) {
-  return trigger_types[num].used_by;
-}
-
-// returns a buffer that contains the name and used-by list for a trigger
-const char *triggerTypeGetNameAndUsedBy(int num) {
-  static char buf[100];
-  sprintf(buf, "%-20s %s", triggerTypeGetName(num), triggerTypeGetUsedBy(num));
-  return buf;
-}
+
+
+//*****************************************************************************
+// tedit OLC functions
+//*****************************************************************************
 
 void tedit_menu(SOCKET_DATA *sock, TRIGGER_DATA *trigger) {
+  // the display line for our trigger type
+  BUFFER *ttype_line = newBuffer(1);
+  if(!*triggerGetType(trigger))
+    bufferCat(ttype_line, "<NONE>");
+  else {
+    bufferCat(ttype_line, triggerGetType(trigger));
+
+    // is it a valid type?
+    if(hashIn(get_tedit_opts(), triggerGetType(trigger)))
+      bprintf(ttype_line, "   (%s)", (char *)hashGet(get_tedit_opts(), 
+						   triggerGetType(trigger)));
+    else
+      bprintf(ttype_line, "   {r* unknown trigger type");
+  }
+
   send_to_socket(sock,
 		 "{g[{c%s{g]\r\n"
 		 "{g1) Name        : {c%s\r\n"
@@ -144,8 +114,11 @@
 		 "{g3) Script Code\r\n",
 		 triggerGetKey(trigger),
 		 triggerGetName(trigger),
-		 (*triggerGetType(trigger) ? triggerGetType(trigger):"<NONE>"));
+		 bufferString(ttype_line));
   script_display(sock, triggerGetCode(trigger), FALSE);
+
+  // garbage collection
+  deleteBuffer(ttype_line);
 }
 
 int tedit_chooser(SOCKET_DATA *sock, TRIGGER_DATA *trigger, const char *option){
@@ -154,10 +127,36 @@
     send_to_socket(sock, "Enter trigger name: ");
     return TEDIT_NAME;
   case '2':
-    send_to_socket(sock, "      {wType                 Usable By\r\n");
-    send_to_socket(sock, "      {y-----------------------------------\r\n");
-    olc_display_table(sock, triggerTypeGetNameAndUsedBy, num_trig_types(), 1);
+    send_to_socket(sock, 
+		   "{w%-18s %-20s%-18s %-22s\r\n", 
+		   "Type", "Usable By", "Type", "Usable By");
+    send_to_socket(sock, "{y------------------------------------------------------------------------------{g\r\n");
+
+    // get our keys, sort them alphabetically, and then list them all
+    HASHTABLE        *opts = get_tedit_opts();
+    LIST             *keys = hashCollect(opts);
+    listSortWith(keys, strcasecmp);
+    LIST_ITERATOR   *key_i = newListIterator(keys);
+    const char        *key = NULL;
+    int             parity = 0;
+
+    // display our keys, one at a time
+    ITERATE_LIST(key, key_i) {
+      send_to_socket(sock, "%-18s %-20s", key, (char *)hashGet(opts, key));
+      parity = (parity + 1) % 2;
+      if(parity == 0)
+	send_to_socket(sock, "\r\n");
+    } deleteListIterator(key_i);
+
+    // need a newline
+    if(parity == 1)
+      send_to_socket(sock, "\r\n");
+
     send_to_socket(sock, "\r\nEnter trigger type: ");
+
+    // garbage collection
+    deleteListWith(keys, free);
+
     return TEDIT_TYPE;
   case '3':
     socketStartEditor(sock, script_editor, triggerGetCodeBuffer(trigger));
@@ -175,6 +174,8 @@
     return TRUE;
 
   case TEDIT_TYPE: {
+    triggerSetType(trigger, arg);
+    /*
     int num = atoi(arg);
     if(num < 0 || num >= num_trig_types())
       return FALSE;
@@ -182,6 +183,8 @@
       triggerSetType(trigger, triggerTypeGetName(num));
       return TRUE;
     }
+    */
+    return TRUE;
   }
 
   default: 
